/******************************************
 * youtube3d                              *
 * Tutor: Paolo Pasteris                  *
 * Progetto Multimediale 11/12 Unimi      *
 ******************************************/
 
import codeanticode.gsvideo.*;

GSCapture camSx, camDx;
GSMovieMaker mm;
int fps;
boolean type;

void setup() 
{
   fps=25;
   type=true;
   frameRate(fps);
   size(320,240);
   camSx = new GSCapture(this, width, height, "/dev/video1");
   camDx = new GSCapture(this, width, height, "/dev/video2");  
   background(0);
   mm = new GSMovieMaker(this, width, height, "youtube3d.ogg",
                        GSMovieMaker.THEORA, GSMovieMaker.HIGH,
                        fps);
}

void draw()
{
  if (camSx.available() == true && camDx.available() == true) {
        camSx.read();
        camDx.read();       
        if (type) image(SideBySide(camSx,camDx),0,0);
        else image(OverUnder(camSx,camDx),0,0);
  }
  loadPixels();
  if (mm.isRecording()) mm.addFrame(pixels);  
}

PImage SideBySide(PImage left, PImage right) {
  PImage out = createImage(left.width, left.height, RGB);
  out.copy(left,0,0,left.width,left.height,0,0,left.width/2,left.height);
  out.copy(right,0,0,right.width,right.height,right.width/2,0,right.width/2,right.height);
  return out;
}

PImage OverUnder(PImage left, PImage right) {
  PImage out= createImage(left.width, left.height, RGB);
  out.copy(left,0,0,left.width,left.height,0,0,left.width,left.height/2);
  out.copy(right,0,0,right.width,right.height,0,right.height/2,right.width,right.height/2);
  return out;
}

void keyPressed() {
  // toggles the recording
  if (key == ' ') {
    if (mm.isRecording()){
      println("...Finished");
      mm.finish();
      exit();
    }else{
      println("Recording...");
      mm.start();
    }
    return;
  }
  if (key == 's'&& !mm.isRecording()) {
    if (type){
      println("Side by Side");
      type=false;
    }else{
      println("Over Under");
      type=true;
    }
    return;
  }
}
